import { Service } from "../service";
import { MongodbService } from "./mongodbService";
import { AuthenticationService, AuthenticationData } from "./authenticationService";
import * as mongodb from "mongodb";
export declare type Callback<T> = (err?: Error, result?: T) => void;
export declare const Errors: any;
export declare class AccountService<TAccountDefinition extends AccountDefinition = AccountDefinition> extends Service {
    readonly name: string;
    protected collectionName: string;
    readonly dependencies: string[];
    services: {
        MongodbService: MongodbService;
        AuthenticationService: AuthenticationService;
    };
    accountCollection: mongodb.Collection;
    initialize(done: any): void;
    create(option: {
        account: TAccountDefinition;
    }, callback: Callback<TAccountDefinition>): void;
    createFromAuthentication(option: {
        authentication: AuthenticationData;
        id?: string;
        name?: string;
        displayName?: string;
        props?: TAccountDefinition["props"];
        role?: TAccountDefinition["role"];
    }, callback: Callback<TAccountDefinition>): void;
    get(id: string, callback: Callback<TAccountDefinition>): void;
    gets(ids: string[], callback: Callback<TAccountDefinition[]>): void;
    update(option: {
        account: TAccountDefinition;
        mongoUpdates?: any;
    }, callback: Callback<TAccountDefinition>): void;
}
export interface AccountDefinition {
    id: string;
    name: string;
    displayName: string;
    role?: string;
    props?: any;
}
