"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
var express = require("express");
var bodyParser = require("body-parser");
var ExpressService = /** @class */ (function (_super) {
    __extends(ExpressService, _super);
    function ExpressService(config) {
        var _this = _super.call(this) || this;
        _this.name = "ExpressService";
        _this.dependencies = ["MongodbService"];
        _this.staticPathes = [];
        var http = config.http || {};
        _this.port = http.port || 8080;
        _this.host = http.host || "0.0.0.0";
        _this.offline = http.offline;
        var staticResources = config.staticResources || [];
        for (var _i = 0, staticResources_1 = staticResources; _i < staticResources_1.length; _i++) {
            var res = staticResources_1[_i];
            _this.static(res.path, res.route);
        }
        return _this;
    }
    ExpressService.prototype.initialize = function (done) {
        this.server = express();
        for (var _i = 0, _a = this.staticPathes; _i < _a.length; _i++) {
            var info = _a[_i];
            this.useStatic(info);
        }
        this.server.use(bodyParser.json({ limit: "2mb" })); // for parsing application/json
        this.server.use(bodyParser.urlencoded({ extended: true, limit: "2mb" })); // for parsing application/x-www-form-urlencoded
        if (!this.offline) {
            this.initHttp(function () {
                done();
            });
        }
        else {
            done();
        }
    };
    ExpressService.prototype.initHttp = function (callback) {
        var _this = this;
        this.httpServer = this.server.listen(parseInt(this.port.toString()), this.host, function () {
            console.log("Express listen at", _this.host + ":" + _this.port);
            callback();
        });
    };
    ExpressService.prototype.asBuiltIn = function () {
        console.log("ExpressService default http://" + this.host + ":" + this.port + "/");
    };
    ExpressService.prototype.static = function (path, route) {
        this.staticPathes.push({
            path: path, route: route
        });
        if (this.server) {
            this.useStatic(this.staticPathes[this.staticPathes.length - 1]);
        }
    };
    ExpressService.prototype.useStatic = function (info) {
        if (!info.path) {
            console.error(info);
            console.error("Static resource requires a path");
            return;
        }
        if (info.route) {
            this.server.use(info.route, express.static(info.path));
        }
        else {
            this.server.use(express.static(info.path));
        }
    };
    return ExpressService;
}(service_1.Service));
exports.ExpressService = ExpressService;
//# sourceMappingURL=expressService.js.map